class iaas::profile::keystone (
  $admin_token = $iaas::params::admin_token,
  $admin_email = $iaas::params::admin_email,
  $admin_password = $iaas::params::admin_password,
  $admin_tenant = $iaas::params::admin_tenant,

  $tenants,
  $users,

##verbose, debug
  $verbose = $iaas::params::verbose,
  $debug = $iaas::params::debug,

  $public_interface = $iaas::params::public_interface,
  $admin_interface = $iaas::params::admin_interface,

  $region = $iaas::params::region,

#VIP1
  $endpoint_main = $iaas::params::main_address,
#VIP2
  $endpoint_admin = $iaas::params::admin_address,

##rhosts
#  $endpoint = hiera('iaas::main_address', undef),
  $rhosts = $iaas::params::rhosts,
  $rabbitmq_user = $iaas::params::user,
  $rabbitmq_password = $iaas::params::password,
) {

##Leave commented if DB is not controller
#  iaas::resources::database { 'keystone': }
  include iaas::resources::connectors

  if $endpoint_admin == '' {
    $real_endpoint_admin = $endpoint_main
  }else{
    $real_endpoint_admin = $endpoint_admin
  }

  class { '::keystone':
##added verbose, debug
    verbose => $verbose,
    debug => $debug,
    admin_token => $admin_token,
    database_connection => $iaas::resources::connectors::keystone,
    admin_bind_host => $::facts["ipaddress_${admin_interface}"],
    public_bind_host => $::facts["ipaddress_${admin_interface}"],
    admin_endpoint => "http://${real_endpoint_admin}:35357",
##rhosts - uncomment as needed
#    rabbit_host => $endpoint,
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
  }

  class { 'keystone::roles::admin':
    email => $admin_email,
    password => $admin_password,
    admin_tenant => $admin_tenant,
  }

  class { 'keystone::endpoint':
    public_url => "http://${endpoint_main}:5000",
    admin_url => "http://${real_endpoint_admin}:35357",
    internal_url => "http://${real_endpoint_admin}:5000",
    region => $region,
  }

  create_resources('iaas::resources::tenant', $tenants)
  create_resources('iaas::resources::user', $users)

}
